#include <EUMF-K.h>
#include <HECH.h>
#include <Properties.h>
#include <Debug.h>

#include <stdio.h>



#define DEBUG "EBR"



HECH * EBR_houseConnect(Properties *conf)
{
	HECH * myHECH = NULL;
	const char * houseIPAddr;
	int measPort;
	int cmdsPort;
	int controlSignalStop;

	if (Properties_getString(conf, "HECH_IP", &houseIPAddr) < 0) {
		fprintf(stderr, "\nAdd in configuration file a line\n\nstring HECH_IP = aString\n");
		exit(1);
	}

	if (Properties_getInt(conf, "HECH_MEASUREMENTS_PORT", &measPort) < 0) {
		fprintf(stderr, "\nAdd in configuration file a line\n\nint HECH_MEASUREMENTS_PORT = anInteger\n");
		exit(1);
	}

	if (Properties_getInt(conf, "HECH_COMMANDS_PORT", &cmdsPort) < 0) {
		fprintf(stderr, "\nAdd in configuration file a line\n\nint HECH_COMMANDS_PORT = anInteger\n");
		exit(1);
	}

	if (Properties_getInt(conf, "controlSignalStop", &controlSignalStop) < 0) {
		fprintf(stderr, "\nAdd in configuration file a line\n\nint controlSignalStop = anInteger\n");
		exit(1);
	}

	myHECH = HECH_new(houseIPAddr, measPort, cmdsPort, controlSignalStop);
	return myHECH;
}





void EBR_houseDisconnect(HECH **myHECH)
{
	HECH_free(myHECH);
}





