#ifndef __HECH_H__
#define __HECH_H__

#include <Array.h>
#include <stdio.h>




typedef enum meas {
	MEAS_ENERGY = 0,
	MEAS_CONSUMPTION,
	MEAS_PRODUCTION,
	MEAS_BATTERY,
	MEAS_PHEV,
	MEAS_PHEV_READY_HOURS,
	MEAS_NUMBER
} Measures;




typedef enum commands {
	CMDS_BATTERY = 0,
	CMDS_PHEV,
	CMDS_NUMBER
} Commands;




typedef struct HECH HECH;

HECH * HECH_new(const char * hostName, int measurementsPort, int commandsPort, int controlSignalStop);

void HECH_free(HECH **);

int HECH_getControlStopSignal(HECH *_this);


int HECH_requestMeasurements(HECH *_this, double *meas);

int HECH_sendCommands(HECH *_this, double *commands);


void HECH_dumpInfo(HECH *_this, FILE *stream);


#endif

