#ifndef __BasicTypeValue_h__
#define __BasicTypeValue_h__

typedef enum { BASIC_TYPE_INT, BASIC_TYPE_LONG, BASIC_TYPE_ULONG, BASIC_TYPE_DOUBLE, BASIC_TYPE_CHAR } BasicType;

typedef struct {
	BasicType type;
	union {
		int i;
		long l;
		unsigned long ul;
		double d;
		char c;
	} value;	
} BasicTypeValue;


size_t BasicType_sizeof(BasicType t);

void BasicTypeValue_fprint(const void* const elem, FILE* f);
int BasicTypeValue_equals(const void* const e1, const void* const e2);

void BasicTypeValue_set(BasicTypeValue* _this, BasicType type, void* value_p);
void BasicTypeValue_setInt(BasicTypeValue* _this, int value);
void BasicTypeValue_setLong(BasicTypeValue* _this, long value);
void BasicTypeValue_setULong(BasicTypeValue* _this, unsigned long value);
void BasicTypeValue_setDouble(BasicTypeValue* _this, double value);
void BasicTypeValue_setChar(BasicTypeValue* _this, char value);


#endif
