#ifndef __BATTERY_H__
#define __BATTERY_H__

#include <stdio.h>

typedef struct Battery Battery;


/**
 *	Input file must be in CSV format, with first line describing fields
 *	in the following order
 * battery_capacity_kwh,charge_speed_kw,discharge_speed_kw,charge_factor_in_0_1,discharge_factor_in_0_1
 */
Battery *Battery_new(const char *filename);

void Battery_free(Battery **_this);

void Battery_dump(Battery *_this, FILE *stream);


void Battery_setStateOfCharge(Battery *_this, double SoC);
double Battery_getStateOfCharge(Battery *_this);
double Battery_getCapacity(Battery *_this);
double Battery_getChargeSpeed(Battery *_this);
double Battery_getDischargeSpeed(Battery *_this);
double Battery_getChargeFactor(Battery *_this);
double Battery_getDischargeFactor(Battery *_this);



void Battery_actuate(Battery *_this, double power, double hours);


void Battery_charge(Battery *_this, double power, double hours);

void Battery_discharge(Battery *_this, double power, double hours);


#endif
