#ifndef __PROCESS_H__
#define __PROCESS_H__

#include <stdio.h>


typedef struct Process Process;


Process *Process_new(char *);

void Process_dispose(Process **);

void Process_dump(Process *, FILE *);

long Process_read(Process *, char *);

/* Write to be implemented yet */
long Process_write(Process *, char *);

/*!
 Returns RAM usage by this Process.
 */
long Process_RAM_Usage(Process *);

/*!
 Dumps Execution time and RAM usage by this Process to the specified stream, 
 by adding also a given string.
 The invocation to Process_dump_Time_RAM_Usage(myProcess, NULL, NULL) only 
 returns execution time.
 */
double Process_dump_Time_RAM_Usage(Process *, const char *, FILE *);

#endif
