#ifndef __RANGE_DOUBLE_H__
#define __RANGE_DOUBLE_H__

typedef struct Range_Double Range_Double;

typedef struct Range_Double_Iterator Range_Double_Iterator;


Range_Double* Range_Double_new(double min, double max, double step);
double Range_Double_min(const Range_Double* const _this);
double Range_Double_max(const Range_Double* const _this);
double Range_Double_step(const Range_Double* const _this);
int Range_Double_size(Range_Double* const _this);
void Range_Double_free(Range_Double** thisP);

Range_Double_Iterator* Range_Double_Iterator_new(Range_Double* const range);
Range_Double_Iterator* Range_Double_Iterator_new_flipping(Range_Double* const range);


int Range_Double_Iterator_hasNext(Range_Double_Iterator* const _this);

//! returns 1 if this->hasNext() == TRUE, and 0 otherwise
int Range_Double_Iterator_next(Range_Double_Iterator* const _this, double* result);

void Range_Double_Iterator_rewind(Range_Double_Iterator* const _this);
void Range_Double_Iterator_free(Range_Double_Iterator** thisP);

#endif




