#ifndef __RANGE_INT_H__
#define __RANGE_INT_H__

#include <stdio.h>

typedef struct Range_Int Range_Int;

typedef struct Range_Int_Iterator Range_Int_Iterator;


Range_Int* Range_Int_new(int min, int max, int step);
int Range_Int_min(const Range_Int* const _this);
int Range_Int_max(const Range_Int* const _this);
int Range_Int_step(const Range_Int* const _this);
int Range_Int_size(const Range_Int* const _this);
void Range_Int_free(Range_Int** thisP);


//! Writes in *indexP the index of 'value' (if exists). Returns 0 on success, -1 on failure
int Range_Int_index(const Range_Int* const this, int value, int* indexP);

//! Writes in *valueP the value of 'index' (if exists). Returns 0 on success, -1 on failure
int Range_Int_value(const Range_Int* const this, int index, int* valueP);

int Range_Int_contains(const Range_Int* const _this, int value);

Range_Int_Iterator* Range_Int_Iterator_new(const Range_Int* const range);
Range_Int_Iterator* Range_Int_Iterator_new_looping(const Range_Int* const range);

void Range_Int_Iterator_setStep(Range_Int_Iterator* const _this, int step);



int Range_Int_Iterator_hasNext(Range_Int_Iterator* const _this);
int Range_Int_Iterator_hasPrev(Range_Int_Iterator* const _this);

//! returns 1 if this->hasNext() == TRUE, and 0 otherwise
int Range_Int_Iterator_next(Range_Int_Iterator* const _this, int* result);
int Range_Int_Iterator_prev(Range_Int_Iterator* const _this, int* result);

void Range_Int_Iterator_rewind(Range_Int_Iterator* const _this);
void Range_Int_Iterator_free(Range_Int_Iterator** thisP);

// Debug only
void Range_Int_Iterator_fprint(const Range_Int_Iterator* const this, FILE* f);
#endif




