#ifndef __TIMEUTILS_H__
#define __TIMEUTILS_H__

#include <stdio.h>


typedef struct TimeUtils TimeUtils;

/* input format must be "YYYY-MM-DD HH:MM:SS" */
TimeUtils *TimeUtils_new(const char *);
void TimeUtils_dispose(TimeUtils **);
TimeUtils *TimeUtils_copy(TimeUtils *);

int TimeUtils_eq(TimeUtils *, TimeUtils *);
int TimeUtils_lt(TimeUtils *, TimeUtils *);

#define TimeUtils_le(a, b) (TimeUtils_lt(a, b) || TimeUtils_eq(a, b))
#define TimeUtils_ge(a, b) (!TimeUtils_lt(a, b))
#define TimeUtils_gt(a, b) (!TimeUtils_le(a, b))

void TimeUtils_addSeconds(TimeUtils **, int);

#define TimeUtils_addMinutes(t, m) (TimeUtils_addSeconds(t, m*60))
#define TimeUtils_addHours(t, h)   (TimeUtils_addSeconds(t, h*60*60))
#define TimeUtils_addDays(t, d)     (TimeUtils_addSeconds(t, d*60*60*24))

void TimeUtils_dump(FILE *, TimeUtils *);
char * TimeUtils_toString(TimeUtils *);

#endif
