#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define DEBUG "Numbers"

static double absoluteTolerance = 1E-6;
static double relativeTolerance = 1E-6;

void Numbers_setAbsoluteTolerance(double t) {
	absoluteTolerance = fabs(t);
}
double Numbers_getAbsoluteTolerance() {
	return absoluteTolerance;
}

void Numbers_setRelativeTolerance(double t) {
	relativeTolerance = fabs(t);
}
double Numbers_getRelativeTolerance() {
	return relativeTolerance;
}

int Numbers_approxEQ(double d1, double d2) {
	if (d1 == d2) return 1;
	
	double absDiff = fabs(d1-d2);
	double max_abs = fabs(d1);
	double abs_d2 = fabs(d2);
	if (abs_d2 > max_abs) max_abs = abs_d2;
	
	return absDiff <= absoluteTolerance ||
		absDiff <= relativeTolerance * max_abs;
}

int Numbers_approxLE(double d1, double d2) {
	return d1 <= d2 || Numbers_approxEQ(d1, d2);
}

int Numbers_approxGE(double d1, double d2) {
	return Numbers_approxLE(d2, d1);
}

double Numbers_relativeError(double d1, double d2) {
	double denominator = d1;
	if (denominator == 0) denominator = relativeTolerance;
	return (d1-d2)/denominator;
}
