#include <stdio.h>
#include <stdlib.h>

#include <Array.h>
#include <Debug.h>

#include <BasicTypeCache.h>

#define DEBUG "TestBasicTypeCache"

typedef struct {
	int x;
	double y;
	char z;
} Cache_Key;

void Cache_Key_fill(Cache_Key* this, int x, double y, char z) {
	this->x = x;
	this->y = y;
	this->z = z;
}

int main(int argc, char** args) {

	BasicTypeCache* cache = BasicTypeCache_new(sizeof(Cache_Key), 10, 10);	
	Cache_Key k = {0};
	double value_d = 0;
	int value_i = 0;
	long value_l = 0;
		
	Cache_Key_fill(&k, 0, 0, 'a');
	value_d = 1;
	BasicTypeCache_put(cache, &k, BASIC_TYPE_DOUBLE, &value_d);

	Cache_Key_fill(&k, 1, 1.111, 'b');
	value_l = 10000;
	BasicTypeCache_put(cache, &k, BASIC_TYPE_LONG, &value_l);


	Cache_Key_fill(&k, 2, 2.222, 'c');
	value_i = 10;
	BasicTypeCache_put(cache, &k, BASIC_TYPE_INT, &value_i);
	
	BasicTypeValue* value = NULL;
	
	Cache_Key_fill(&k, 0, 0, 'a');	
	value = BasicTypeCache_get(cache, &k);
	fprintf(stderr, "\n\nCache (0,0,a): ");
	BasicTypeValue_fprint(value, stderr);

	Cache_Key_fill(&k, 1, 1.111, 'b');
	value = BasicTypeCache_get(cache, &k);
	fprintf(stderr, "\n\nCache (1,1.111,b): ");
	BasicTypeValue_fprint(value, stderr);


	Cache_Key_fill(&k, 2, 2.222, 'c');
	value = BasicTypeCache_get(cache, &k);
	fprintf(stderr, "\n\nCache (2,2.222,c): ");
	BasicTypeValue_fprint(value, stderr);
	fprintf(stderr, "\n");
	
	
	return 0;
	
}

