#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <StringUtils.h>

#include <CommandLineInterface.h>

int main(int argc, char** args) {	

	CommandLineInterface* cli = CommandLineInterface_new(args[0], "Test CLI\nJust for test purposes");
	
	CommandLineInterface_addStringOption(cli, "option1", "Mandatory STRING option 1");
	CommandLineInterface_addIntOption_withDefault(cli, "option2", 2, "Non mandatory INT option 2");
	CommandLineInterface_addDoubleOption(cli, "option3", "Mandatory DOUBLE option 3");	
	CommandLineInterface_addFlag(cli, "flag1", "Flag 1");
	
	CommandLineInterface_processArgs(cli, argc, args);


	fprintf(stderr, "Getting option values...\n");
	
	const char* const o1 = CommandLineInterface_getStringOption(cli, "option1");
	fprintf(stderr, "\n - Option1: '%s'", o1);
	int o2 = CommandLineInterface_getIntOption(cli, "option2");
	fprintf(stderr, "\n - Option2: '%d'", o2);
	
	double o3 = CommandLineInterface_getDoubleOption(cli, "option3");
	fprintf(stderr, "\n - Option3: '%lf'", o3);
	
	int o4 = CommandLineInterface_getFlag(cli, "option4");
	fprintf(stderr, "\n - Option4: '%s'", (o4 ? "true" : "false") );
	





	CommandLineInterface_free(&cli);
	fprintf(stderr, "\nDone.\n");
	return 0;
}

